diff --git a/fw/hpack.c b/fw/hpack.c
index cf28ffb0e..9bb9a5a7f 100644
--- a/fw/hpack.c
+++ b/fw/hpack.c
@@ -1442,6 +1442,9 @@ tfw_hpack_decode(TfwHPack *__restrict hp, unsigned char *__restrict src,
 
 			NEXT_STATE(HPACK_STATE_VALUE);
 
+			if (unlikely(src >= last))
+				goto out;
+
 			fallthrough;
 		}
 		case HPACK_STATE_VALUE:
